% -------- angul_fear_operator -----------
%this is the topology significance - VERY HARD TO CALCULATE!!!!!!!
%therefore - computed only once
%this operator is activated on the global matrix: ANGUL_MAT 
% flow:
% check if GLOBAL_ANGUL_FEAR_MAT1 is not yet filled (isempty).
% - if not, calculate it.
% - assign it to the output.
% NOTE: in order to refresh, extriour "clear" is not enough-
% an explicite assignmrnt to [] should be done !!!!!!!!!
function ANGUL_FEAR_MAT = angul_fear_operator(IN_SIZE,IN_TOPO)
global GLOBAL_ANGUL_FEAR_MAT;
% calculation is done only once
if isempty(GLOBAL_ANGUL_FEAR_MAT)
   Reset_MAT(IN_SIZE);
	calculate_cells_fear(IN_SIZE,IN_TOPO);
   normalize_MAT;
end
% assign the global fear matrix to the output
ANGUL_FEAR_MAT  = GLOBAL_ANGUL_FEAR_MAT;

% END OF angul_fear_operator
% -----------------------------------------------------------------

% -------- compute_cell_fear -----------
function OUT_CELL_FEAR_MAT = compute_cell_fear(IN_SIZE,IN_M,IN_N,IN_TOPO_VALUE)
global DISTANCE_MAT;
global CELL_FEAR_AUX;
%in order to reuse calculations, we calculate ONLY once the relation
%of the "force"effect to the distance
if isempty(CELL_FEAR_AUX)
   CELL_FEAR_AUX = min((exp(1./(DISTANCE_MAT+1)))-1,1);
end   
% the matrix is initialized with the biggest values possible
% the distance matrix is layed over the cell matrix;
OUT_CELL_FEAR_MAT = CELL_FEAR_AUX(IN_SIZE-IN_M+1:2*IN_SIZE-IN_M,IN_SIZE-IN_N+1:2*IN_SIZE-IN_N);
OUT_CELL_FEAR_MAT = OUT_CELL_FEAR_MAT./(IN_TOPO_VALUE+1);

% END OF compute_cell_fear
% -----------------------------------------------------------------

function Reset_MAT(IN_SIZE)
global GLOBAL_ANGUL_FEAR_MAT;
GLOBAL_ANGUL_FEAR_MAT = zeros(IN_SIZE);

function calculate_cells_fear(IN_SIZE,IN_TOPO)
global GLOBAL_ANGUL_FEAR_MAT;
for m=1:IN_SIZE
	for n=1:IN_SIZE
   	CELL_FEAR = compute_cell_fear(IN_SIZE,m,n,IN_TOPO(m,n));
   	GLOBAL_ANGUL_FEAR_MAT = GLOBAL_ANGUL_FEAR_MAT + CELL_FEAR;
	end
end

function normalize_MAT
global GLOBAL_ANGUL_FEAR_MAT;

% normalize the total field to range between 0-1.
GLOBAL_ANGUL_FEAR_MAT = GLOBAL_ANGUL_FEAR_MAT-min(min(GLOBAL_ANGUL_FEAR_MAT));
GLOBAL_ANGUL_FEAR_MAT = GLOBAL_ANGUL_FEAR_MAT./max(max(GLOBAL_ANGUL_FEAR_MAT));
GLOBAL_ANGUL_FEAR_MAT = 1 - GLOBAL_ANGUL_FEAR_MAT; 
   
%GLOBAL_ANGUL_FEAR_MAT = GLOBAL_ANGUL_FEAR_MAT + 2*IN_TOPO;
GLOBAL_ANGUL_FEAR_MAT = GLOBAL_ANGUL_FEAR_MAT-min(min(GLOBAL_ANGUL_FEAR_MAT));
GLOBAL_ANGUL_FEAR_MAT = GLOBAL_ANGUL_FEAR_MAT./max(max(GLOBAL_ANGUL_FEAR_MAT));
   
